#!/bin/sh
# (c) Aurimas Fišeras <aurimas@gmail.com>, 2011
# License LGPLv3+ / MPL
# Creates a simple hunspell spell check dictionary for LibreOffice ure

#Run this script in offapi/

#TODO:
#sequence< ::com::sun::star::beans::Pair< string, string > >
#            getAllItems();
#XDragSource DragSource;
#[in] XSlidePreviewCacheListener xListener)

#Create lists for various parts of LibreOffice API
#functions
find -iname '*.idl' | xargs cat | tr '\n' ' ' | grep -o -E '[[:alnum:]]+[[:space:]]+[[:alnum:]]+[A-Z][[:alnum:]]+[[:space:]]*\(' | sed -E 's/( |\t)+/ /g' | cut -d ' ' -f 2 | tr -d ' (' | sort -u > func.list

#define:
find -iname '*.idl' | xargs cat | tr '\n' ' ' | grep -o -E '\<[A-Z][[:alnum:]]+[[:space:]]+[[:alnum:]]+[[:space:]]*\([^)]*\)' | sed -E 's/[ \t]+/ /g' | grep -E '(\([[:space:]]*\)|\[[[:space:]]*in[[:space:]]*\])' | sed -E 's/\(.*//' | tr ' ' '\n' | sort -u > define.list

#sequence:
find -iname '*.idl' | xargs cat | tr '\n' ' ' | grep -o -E '\<(sequence|Pair)[[:space:]]*<[^>]*>[[:space:]]*[[:alnum:]]+' | sed -E 's/(sequence|Pair|scope)//g' | tr '<=":>\t' ' ' | sed 's/ /\n/g' | sort -u > sequence.list

#foo::bar defines:
find -iname '*.idl' | xargs cat | tr '\n' ' ' | grep -o -E '([0-9a-zA-Z]+::)+([0-9a-zA-Z]+)[[:space:]]+[[:alnum:]]+' | sed -E 's/::| |\t/\n/g' | grep -v -E '^[0-9]*$' | sort -u > define.list

#interface, service, singleton, struct, etc.:
find -iname '*.idl' | xargs cat | tr '\n' ' ' | grep -o -E '(constants|enum|interface|service|singleton|struct)[[:space:]]+[[:alnum:][:space:]:]+[;{]' | grep -v 'deprecated' | sed -E 's/constants|enum|service|interface|singleton|struct|;|\{//g' | tr ':' '\n' | tr -d ' ' | sort -u > interface.list

#[in, out, property]:
find -iname '*.idl' | xargs grep -h -o -E '(attribute|bound|in|inout|maybevoid|oneway|optional|out|property|readonly)[[:space:]]*\][[:space:]]+[^,();{]*' | grep -v -E 'sequence|\.' | awk -F' ' '{print $NF}' | sort -u > attrib.list

#idl:
find -iname '*.idl' | xargs grep -h -o -E '_([0-9a-zA-Z])+_idl' | sed -E 's/_(idl)?//g' | sort -u > idl.list

#code, type:
find -iname '*.idl' | xargs grep -h -o -E '<(code|type)([[:space:]]+scope[[:space:]]*=[[:space:]]*"[^"]+"[[:space:]]*)?>[[:alnum:]]+</\1>' | sed -E 's/[ \t]+scope[^"]*.*"//' | sed -E 's/<\/?(code|type)>//g' | grep -v -E '^[0-9]*$' | sort -u > code.list

#method, member:
find -iname '*.idl' | xargs grep -h -o -E '<(method|member)>[^<]*</\1>' | sed -E 's/<\/?(method|member)>//g' | tr -d '()' | sed 's/::/\n/g' | sort -u > method.list

#published interface, service, enum, struct:
find -iname '*.idl' | xargs grep -h -o -E 'published[[:space:]]+(enum|interface|service|struct)[[:space:]]+[^[:space:]]*?' | tr -d ':;{' | tr '\t' ' ' | sed -E 's/[ \t]+/ /g' | cut -d ' ' -f 3 | sort -u > published.list

#variables:
find -iname '*.idl' | xargs grep -h -o -E '\<(any|boolean|byte|char|double|float|hyper|long|short||string|void)\>[[:space:]]+[^[:space:]=\(\),;>]*?' | tr '\t' ' ' | sed -E 's/[ \t]+/ /g' | cut -d ' ' -f 2 | grep -v -E '\.|"|'\' | sort -u > variables.list

#@param/throws:
find -iname '*.idl' | xargs grep -h -o -E '@\<(param|throws)\>[[:space:]]+[^[:space:]=\(\),;:>]*?' | tr '\t' ' ' | sed -E 's/[ \t]+/ /g' | cut -d ' ' -f 2 | tr -d '[]' | sort -u > @.list

#foo::bar only:
find -iname '*.idl' | xargs grep -h -o -E '([0-9a-zA-Z]+::)+([0-9a-zA-Z]+)' | sed 's/::/\n/g' | grep -v -E '^[0-9]*$' | sort -u > tree.list

#constants:
find -iname '*.idl' | xargs grep -h -o -E 'const[[:space:]]+[^[:space:]]*[[:space:]]+[^[:space:]=]*' | grep -v -E 'scope|\.' | tr '\t' ' ' | sed -E 's/[ \t]+/ /g' | cut -d ' ' -f 3 | sort -u > consts.list 

#filenames:
find -iname '*.idl' | sed 's/\(.*\)\..*/\1/' | awk -F/ '{print $NF}' | sort -u > files.list

#Compile all lists to 1 hunspell compatible dictionary:
cat *.list | tr '_' '\n' | sed '/\t?^$/d' | grep -v -E '(<|>|/)' | sort -u > ~/libo.dic && sed -i "1i`wc -l ~/libo.dic | grep -o '[0-9]*'`" $HOME/libo.dic

#To spellcheck run something like this in a folder containing idl files:
#hunspell -d en_US,$HOME/libo -p .hunspell_en_US_libo *.idl

